<template>
  <a
    v-if="needNormalLink"
    :href="href"
    v-bind="$attrs"
    :class="normalLinkClasses">
    <slot/>
  </a>
  <nuxt-link
    v-else-if="isFrontUrl && !isDiffDomain"
    :to="href"
    v-bind="$attrs">
    <slot/>
  </nuxt-link>
  <a
    v-else
    :href="fullHref"
    v-bind="$attrs"
    :class="normalLinkClasses">
    <slot/>
  </a>
</template>

<script>
import { has } from 'lodash-es';

export default {
  name: 'FrontappLink',
  props: {
    href: {
      type: String,
      default: '',
    },
    domain: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      frontUrls: [
        '/tyres',
        '/wheels',
        '/check-auto',
        '/about-us',
        '/partner',
        '/faq',
        '/poisk-po-nomeru',
        '/request-to-spare',
        '/cart',
        '/about',
        '/do',
        '/top-samyh-populyarnyh-avtozapchastej',
        '/top-zapchastej-v-nalichii',
        '/seller',
        '/categories',
        '/cabinet/wrench/profile',
        '/cabinet/wrench/organization-info',
        '/cabinet/wrench/organization-sto',
        '/cabinet/wrench/notification-setup',
        '/cabinet/statistics',
        '/users/recover-password',
        '/users/register',
      ],
    };
  },
  computed: {
    fullHref() {
      if (this.isDiffDomain && !this.href.match(/\/\//)) {
        return `//${this.targetDomainFull}${this.href}`;
      }
      return this.href;
    },
    targetDomainFull() {
      let result = this.$store.state.domain;
      if (this.domain && has(this.$config.domains, this.domain)) {
        result = this.$config.domains[this.domain];
      }
      return result;
    },
    isDiffDomain() {
      return this.targetDomainFull !== this.$store.state.domain;
    },
    isFrontUrl() {
      return Boolean(this.href)
        && Boolean(
          this.href === '/'
          || this.frontUrls.filter(value => this.href.startsWith(value)).length
        );
    },
    needNormalLink() {
      const toCabinet = this.href.startsWith('/cabinet') && (this.$route && !this.$route.path.startsWith('/cabinet'));
      const fromCabinet = !this.href.startsWith('/cabinet') && (this.$route && this.$route.path.startsWith('/cabinet'));
      return (!this.isDiffDomain && this.href === this.$route.path) || toCabinet || fromCabinet;
    },
    normalLinkClasses() {
      const normalLinkClasses = [];
      if (this.isDiffDomain) {
        return normalLinkClasses;
      }

      if (this.$attrs['active-class'] && this.$route.path.startsWith(this.href)) {
        normalLinkClasses.push(this.$attrs['active-class']);
      }
      if (this.$attrs['exact-active-class'] && this.$route.path === this.href) {
        normalLinkClasses.push(this.$attrs['exact-active-class']);
      }
      return normalLinkClasses;
    },
  },
};
</script>

<style scoped lang="scss">
</style>
